<?php
    function bbcode($markup){
        $markup = str_replace('&', '&', $markup);
        $markup = str_replace('<', '<', $markup);
        $markup = str_replace('>', '>', $markup);
        $preg = array(    
            // Text arrtibutes
            '~\[s\](.*?)\[\/s\]~si'        => '<del>$1</del>',
            '~\[b\](.*?)\[\/b\]~si'                 => '<strong>$1</strong>',
            '~\[i\](.*?)\[\/i\]~si'                 => '<em>$1</em>',
            '~\[u\](.*?)\[\/u\]~si'                 => '<u>$1</u>',

            //align
            '~\[center\](.*?)\[\/center\]~si'       => '<div style="text-align: center">$1</div>',
            '~\[right\](.*?)\[\/right\]~si'         => '<div style="text-align: right">$1</div>',

            // links
            '~\[url\]www\.(.*?)\[\/url\]~si'        => '<a href="http://www.$1">$1</a>',
            '~\[url\](.*?)\[\/url\]~si'             => '<a href="$1">$1</a>',
            '~\[url=(.*?)?\](.*?)\[\/url\]~si'      => '<a href="$1">$2</a>',
        );

        return preg_replace(array_keys($preg), array_values($preg), $markup);
    }

    function getDataFile($file,$n = 0)
    { 
        $data = '';
        if(file_exists($file))
        {
            @$data = file_get_contents($file);
            if(!$data)
            {
                $n++;
                if($n < 15)
                {
                    usleep(200000);  
                    $data = getDataFile($file,$n); 
                }  
            } 
        }
        else
        {
            $n++;
            if($n < 8)
            {
                usleep(300000); 
                $data = getDataFile($file,$n); 
            }
        }
        return $data;
    }

    function getDateInfo($date)
    {
        $dateResult = array('d'=>'','t'=>'');
        list($d,$t) = explode('.',$date,2);
        if(isset($d) || $d > 0)
        {
            // unix time
            $unixTime = $d*86400-25569*86400;
            $dateResult['d'] = date('d.m.Y',$unixTime);
        }

        if(isset($t) || $t > 0)
        {
            $times = 86400*('0.'.$t);
            $times = round($times);

            $time = new DateTime('@'.$times);
            $dateResult['t'] = $time->format('H:i:s');
        }

        return $dateResult;
    }

    function DeleteFileUsed($file,$n = 0)
    {
        sleep(1);
        @$data = file_get_contents($file);
        if($data)
        {
            unlink($file); 
        }
        else
        {
            $n++;
            if($n < 3)
            {
                DeleteFileUsed($file,$n);
            }
        }
    }

    function SendQuery($name,$data)
    {
        @$sendFile = file_put_contents('query/'.$name.'.txt',$data);
        usleep(500);
        if(!$sendFile)
        {
            SendQuery($name,$data);
        }
    }

    // функция вывода пользователей онлайн
    function GetOnline($type = 0,$n = 0)
    {
        $array = array();
        @$data = file_get_contents('data/user_online.txt');
        if($data)
        {
            $data = trim($data);
            $array = json_decode($data,true);
        }
        else
        {
            $n++;
            if($n < 3)
            {
                $array = GetOnline($type,$n);
            }
        }
        return $array; 
    }

    // функция вывода списка каналов с количество онлайн пользователей 0 - вывод всех каналов, 1 - вывод только где онлайн больше нуля
    function GetChannel($type = 0)
    {
        $array = array();
        @$data = file('data/channel_list.txt');
        if($data)
        {
            foreach($data as $n=>$value)
            {
                if($value != '')
                {
                    list($Channel,$Online,$Topic) = explode('::',$value,3);
                    $Channel = trim($Channel);
                    $Topic = trim($Topic);
                    $Online = trim($Online);
                    if($type == 0 || ($type == 1 && $Online > 0))
                    {
                        $array[$n]['name'] = $Channel;
                        $array[$n]['topic'] = $Topic;
                        $array[$n]['online'] = $Online;
                    }
                }

            }
        }
        else
        {
            $n++;
            if($n < 3)
            {
                $array = GetOnline($type,$n);
            }
        }
        return $array;
    }

    function getDateForBase($date)
    {
        $result = '';
        list($a,$b) = explode(' ',$date,2);
        if(isset($a) && isset($b))
        {
            list($a1,$a2,$a3) = explode('.',$a,3);
            if(isset($a1) && isset($a2) && isset($a3))
            {
                $result .= $a3.'-'.$a2.'-'.$a1.' '.$b;
            } 
        }
        return $result;
    }

    function SendQueryToCommfort($type,$data = '')
    {
        mysql_query("INSERT INTO `console` (`type` ,`data`) VALUES ('".$type."',  '".$data."');"); 
    }

    function JsonDecodeUser($json)
    {
        $json = json_encode($json);
        settype($json, "string");
        $cyr_chars = array (
            '\u0430' => 'а', '\u0410' => 'А',
            '\u0431' => 'б', '\u0411' => 'Б',
            '\u0432' => 'в', '\u0412' => 'В',
            '\u0433' => 'г', '\u0413' => 'Г',
            '\u0434' => 'д', '\u0414' => 'Д',
            '\u0435' => 'е', '\u0415' => 'Е',
            '\u0451' => 'ё', '\u0401' => 'Ё',
            '\u0436' => 'ж', '\u0416' => 'Ж',
            '\u0437' => 'з', '\u0417' => 'З',
            '\u0438' => 'и', '\u0418' => 'И',
            '\u0439' => 'й', '\u0419' => 'Й',
            '\u043a' => 'к', '\u041a' => 'К',
            '\u043b' => 'л', '\u041b' => 'Л',
            '\u043c' => 'м', '\u041c' => 'М',
            '\u043d' => 'н', '\u041d' => 'Н',
            '\u043e' => 'о', '\u041e' => 'О',
            '\u043f' => 'п', '\u041f' => 'П',
            '\u0440' => 'р', '\u0420' => 'Р',
            '\u0441' => 'с', '\u0421' => 'С',
            '\u0442' => 'т', '\u0422' => 'Т',
            '\u0443' => 'у', '\u0423' => 'У',
            '\u0444' => 'ф', '\u0424' => 'Ф',
            '\u0445' => 'х', '\u0425' => 'Х',
            '\u0446' => 'ц', '\u0426' => 'Ц',
            '\u0447' => 'ч', '\u0427' => 'Ч',
            '\u0448' => 'ш', '\u0428' => 'Ш',
            '\u0449' => 'щ', '\u0429' => 'Щ',
            '\u044a' => 'ъ', '\u042a' => 'Ъ',
            '\u044b' => 'ы', '\u042b' => 'Ы',
            '\u044c' => 'ь', '\u042c' => 'Ь',
            '\u044d' => 'э', '\u042d' => 'Э',
            '\u044e' => 'ю', '\u042e' => 'Ю',
            '\u044f' => 'я', '\u042f' => 'Я',

        );

        foreach ($cyr_chars as $cyr_char_key => $cyr_char) {
            $json = str_replace($cyr_char_key, $cyr_char, $json);
        }

        return $json;
    }

    function GetResult($type,$n = 0)
    {
        $result = '';
        $select = mysql_query("SELECT * FROM `result` WHERE `type` = '".$type."' LIMIT 0,1");
        if(mysql_num_rows($select) > 0)
        {
            $nt = mysql_fetch_array($select);
            $result = $nt['data'];
        }
        else
        {
            $n++;
            if($n < 15)
            {
                sleep(1);
                $result = GetResult($type,$n);
            }
        }
        return $result;
    }

    function DestroyType($type)
    {
        mysql_query("DELETE FROM `result` WHERE `type` = '".$type."'");
    }

    function ValidateIp($ip){
        $reguklarka = '/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/';
        if ( preg_match($reguklarka, $ip) ) :
            return true;
            endif;
        return false;
    }

    function SendQueryPost($UrlQuery,$arrayPost) {
        $data = null;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
        curl_setopt($ch, CURLOPT_NOSIGNAL, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $UrlQuery);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $arrayPost);       
        $data = curl_exec($ch);
        curl_close($ch);
        return $data;
    }

    function showPeriod($time) {
        return sprintf("%02d:%02d:%02d", (int)($time / 3600), (int)(($time % 3600) / 60), $time % 60);
    }
    
    function seconds2times($seconds)
    {
        $times = array();

        // считать нули в значениях
        $count_zero = false;

        // количество секунд в году не учитывает високосный год
        // поэтому функция считает что в году 365 дней
        // секунд в минуте|часе|сутках|году
        $periods = array(60, 3600, 86400, 31536000);

        for ($i = 3; $i >= 0; $i--)
        {
            $period = floor($seconds/$periods[$i]);
            if (($period > 0) || ($period == 0 && $count_zero))
            {
                $times[$i+1] = $period;
                $seconds -= $period * $periods[$i];

                $count_zero = true;
            }
        }

        $times[0] = $seconds;
        return $times;
    }

?>